SystemOrganization addCategory: #'Obj1-preguntados'!
SystemOrganization addCategory: 'Obj1-preguntados-model'!
SystemOrganization addCategory: 'Obj1-preguntados-specs'!

Object subclass: #Etapa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

Etapa class
	instanceVariableNames: 'giroDeRuleta responderPregunta elegirPersonaje'!

!Etapa commentStamp: '<historical>' prior: 0!
Soy una etapa de juego. Denoto el estado del juego en un momento dado.!

Etapa class
	instanceVariableNames: 'giroDeRuleta responderPregunta elegirPersonaje'!

!Etapa class methodsFor: 'accesing' stamp: 'ArielAlvarez 10/28/2015 01:58'!
giroDeRuleta
	^giroDeRuleta ! !

!Etapa class methodsFor: 'accesing' stamp: 'ArielAlvarez 10/28/2015 01:58'!
initialize
	super initialize.
	giroDeRuleta := EtapaGiroDeRuleta new.
	! !

Etapa subclass: #EtapaGiroDeRuleta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!EtapaGiroDeRuleta commentStamp: '<historical>' prior: 0!
Soy la etapa en la cual el jugador debe girar la ruleta!

Object subclass: #Jugador
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!Jugador commentStamp: '<historical>' prior: 0!
Soy un jugador del juego Preguntados!

!Jugador methodsFor: 'public' stamp: 'ArielAlvarez 10/27/2015 21:24'!
desafiaA: otroJugador 
	^Partida newConDesafiante: self yDesafiado: otroJugador! !

Object subclass: #Partida
	instanceVariableNames: 'desafiante desafiado turno'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!Partida commentStamp: '<historical>' prior: 0!
Soy una partida de preguntados!

!Partida class methodsFor: 'creation' stamp: 'ArielAlvarez 10/27/2015 21:24'!
newConDesafiante: unJugador yDesafiado: otroJugador
	^(Partida new) inicializarConDesafiante: unJugador contra: otroJugador.! !

!Partida methodsFor: 'public' stamp: 'ArielAlvarez 10/27/2015 21:25'!
estaIniciada
	^true! !

!Partida methodsFor: 'initialization' stamp: 'ArielAlvarez 10/27/2015 21:42'!
inicializarConDesafiante: unJugador contra: otroJugador 
	desafiante := unJugador.
	desafiado := otroJugador.
	turno := (Turno new) inicializarConActual: desafiante ySiguiente: desafiado.
	^self! !

!Partida methodsFor: 'public' stamp: 'ArielAlvarez 10/27/2015 21:40'!
jugador
	self shouldBeImplemented.! !

!Partida methodsFor: 'public' stamp: 'ArielAlvarez 10/27/2015 21:38'!
siguienteTurno
	self shouldBeImplemented.! !

!Partida methodsFor: 'public' stamp: 'AlvarezAriel 11/17/2015 22:36'!
turnoActual
	^turno
! !

Object subclass: #Turno
	instanceVariableNames: 'jugadorActual jugadorSiguiente etapa'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-model'!

!Turno commentStamp: '<historical>' prior: 0!
Soy un turno en una partida. !

!Turno methodsFor: 'accesing' stamp: 'ArielAlvarez 10/28/2015 01:44'!
etapa
	^etapa! !

!Turno methodsFor: 'initialization' stamp: 'ArielAlvarez 10/28/2015 01:59'!
inicializarConActual: aJugador ySiguiente: aJugador2 
	jugadorActual := aJugador.
	jugadorSiguiente := aJugador2.
	etapa := Etapa giroDeRuleta.
	^self! !

!Turno methodsFor: 'public' stamp: 'ArielAlvarez 10/27/2015 21:44'!
jugador
	^jugadorActual ! !

TestCase subclass: #TestPreguntados
	instanceVariableNames: 'jugadorDesafiante otroJugador partida'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Obj1-preguntados-specs'!

!TestPreguntados methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 10:14'!
setUp
	jugadorDesafiante := Jugador new.
	otroJugador := Jugador new.
	partida := jugadorDesafiante desafiaA: otroJugador! !

!TestPreguntados methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 10:15'!
test_AlComenzarUnTurnoElMismoSeEncuentraEnLaEtapaDeGiroDeRuleta
	self assert: partida turnoActual etapa equals: Etapa giroDeRuleta! !

!TestPreguntados methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 10:14'!
test_AlIniciarseUnaPartidaElPrimerTurnoCorrespondeAlJugadorDesafiante
	self assert: partida turnoActual jugador equals: jugadorDesafiante! !

!TestPreguntados methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 11/18/2015 10:14'!
test_UnJugadorPuedeIniciarUnaPartidaDesafiandoAOtroJugador
	self assert: partida estaIniciada

! !
Etapa initialize!
